package nme.installer;


import nme.display.Bitmap;
import nme.display.BitmapData;
import nme.media.Sound;
import nme.net.URLRequest;
import nme.text.Font;
import nme.utils.ByteArray;
import ApplicationMain;


/**
 * ...
 * @author Joshua Granick
 */

class Assets {
	
	
	public static var cachedBitmapData:Hash<BitmapData> = new Hash<BitmapData>();
	
	
	public static function getBitmapData (id:String, useCache:Bool = true):BitmapData {
		
		// Should be bitmapData.clone (), but stopped working in recent Jeash builds
		// Without clone, BitmapData is already cached, so ignoring the hash table for now
		
		switch (id) {
			
			case "gfx/debug/console_debug.png": return cast (ApplicationMain.loaders.get ("gfx/debug/console_debug.png").contentLoaderInfo.content, Bitmap).bitmapData;
			case "gfx/debug/console_logo.png": return cast (ApplicationMain.loaders.get ("gfx/debug/console_logo.png").contentLoaderInfo.content, Bitmap).bitmapData;
			case "gfx/debug/console_output.png": return cast (ApplicationMain.loaders.get ("gfx/debug/console_output.png").contentLoaderInfo.content, Bitmap).bitmapData;
			case "gfx/debug/console_pause.png": return cast (ApplicationMain.loaders.get ("gfx/debug/console_pause.png").contentLoaderInfo.content, Bitmap).bitmapData;
			case "gfx/debug/console_play.png": return cast (ApplicationMain.loaders.get ("gfx/debug/console_play.png").contentLoaderInfo.content, Bitmap).bitmapData;
			case "gfx/debug/console_step.png": return cast (ApplicationMain.loaders.get ("gfx/debug/console_step.png").contentLoaderInfo.content, Bitmap).bitmapData;
			case "gfx/preloader/haxepunk.png": return cast (ApplicationMain.loaders.get ("gfx/preloader/haxepunk.png").contentLoaderInfo.content, Bitmap).bitmapData;
			case "gfx/Cursor.png": return cast (ApplicationMain.loaders.get ("gfx/Cursor.png").contentLoaderInfo.content, Bitmap).bitmapData;
			case "gfx/Intro.png": return cast (ApplicationMain.loaders.get ("gfx/Intro.png").contentLoaderInfo.content, Bitmap).bitmapData;
			case "gfx/Player1.png": return cast (ApplicationMain.loaders.get ("gfx/Player1.png").contentLoaderInfo.content, Bitmap).bitmapData;
			case "gfx/Player2.png": return cast (ApplicationMain.loaders.get ("gfx/Player2.png").contentLoaderInfo.content, Bitmap).bitmapData;
			case "gfx/Tiles1.png": return cast (ApplicationMain.loaders.get ("gfx/Tiles1.png").contentLoaderInfo.content, Bitmap).bitmapData;
			case "gfx/Tiles2.png": return cast (ApplicationMain.loaders.get ("gfx/Tiles2.png").contentLoaderInfo.content, Bitmap).bitmapData;
			case "gfx/Winner1.png": return cast (ApplicationMain.loaders.get ("gfx/Winner1.png").contentLoaderInfo.content, Bitmap).bitmapData;
			case "gfx/Winner2.png": return cast (ApplicationMain.loaders.get ("gfx/Winner2.png").contentLoaderInfo.content, Bitmap).bitmapData;
			
		}
		
		return null;
		
	}
	
	
	public static function getBytes (id:String):ByteArray {
		
		switch (id) {
			
			case "gfx/debug/console_debug.png": return cast (ApplicationMain.urlLoaders.get ("gfx/debug/console_debug.png").data, ByteArray);
			case "gfx/debug/console_logo.png": return cast (ApplicationMain.urlLoaders.get ("gfx/debug/console_logo.png").data, ByteArray);
			case "gfx/debug/console_output.png": return cast (ApplicationMain.urlLoaders.get ("gfx/debug/console_output.png").data, ByteArray);
			case "gfx/debug/console_pause.png": return cast (ApplicationMain.urlLoaders.get ("gfx/debug/console_pause.png").data, ByteArray);
			case "gfx/debug/console_play.png": return cast (ApplicationMain.urlLoaders.get ("gfx/debug/console_play.png").data, ByteArray);
			case "gfx/debug/console_step.png": return cast (ApplicationMain.urlLoaders.get ("gfx/debug/console_step.png").data, ByteArray);
			case "gfx/preloader/haxepunk.png": return cast (ApplicationMain.urlLoaders.get ("gfx/preloader/haxepunk.png").data, ByteArray);
			case "font/04B_03__.ttf": return cast (ApplicationMain.urlLoaders.get ("font/04B_03__.ttf").data, ByteArray);
			case "gfx/Cursor.png": return cast (ApplicationMain.urlLoaders.get ("gfx/Cursor.png").data, ByteArray);
			case "gfx/Intro.png": return cast (ApplicationMain.urlLoaders.get ("gfx/Intro.png").data, ByteArray);
			case "gfx/Player1.png": return cast (ApplicationMain.urlLoaders.get ("gfx/Player1.png").data, ByteArray);
			case "gfx/Player2.png": return cast (ApplicationMain.urlLoaders.get ("gfx/Player2.png").data, ByteArray);
			case "gfx/Tiles1.png": return cast (ApplicationMain.urlLoaders.get ("gfx/Tiles1.png").data, ByteArray);
			case "gfx/Tiles2.png": return cast (ApplicationMain.urlLoaders.get ("gfx/Tiles2.png").data, ByteArray);
			case "gfx/Winner1.png": return cast (ApplicationMain.urlLoaders.get ("gfx/Winner1.png").data, ByteArray);
			case "gfx/Winner2.png": return cast (ApplicationMain.urlLoaders.get ("gfx/Winner2.png").data, ByteArray);
			
		}
		
		return null;
		
	}
	
	
	public static function getFont (id:String):Font {
		
		switch (id) {
			
			case "font/04B_03__.ttf": var font = cast (new NME_font_04b_03___ttf (), Font); return font; 
			
		}
		
		return null;
		
	}
	
	
	public static function getSound (id:String):Sound {
		
		switch (id) {
			
			
		}
		
		return null;
		
	}
	
	
	public static function getText (id:String):String {
		
		switch (id) {
			
			
		}
		
		return null;
		
	}
	
	
}