class ApplicationMain
{

	#if waxe
	static public var frame : wx.Frame;
	static public var autoShowFrame : Bool = true;
	#if nme
	static public var nmeStage : wx.NMEStage;
	#end
	#end
	
	public static function main()
	{
		#if nme
		nme.Lib.setPackage("Heddjel", "Main", "com.LD26.app", "1.0.0");
		
		#end
		
		#if waxe
		wx.App.boot(function()
		{
			
			frame = wx.Frame.create(null, null, "Glow", null, { width: 660, height: 660 });
			
			#if nme
			var stage = wx.NMEStage.create(frame, null, null, { width: 660, height: 660 });
			#end
			
			Main.main();
			
			if (autoShowFrame)
			{
				wx.App.setTopWindow(frame);
				frame.shown = true;
			}
		});
		#else
		
		nme.Lib.create(function()
			{ 
				if (660 == 0 && 660 == 0)
				{
					nme.Lib.current.stage.align = nme.display.StageAlign.TOP_LEFT;
					nme.Lib.current.stage.scaleMode = nme.display.StageScaleMode.NO_SCALE;
				}
				
				var hasMain = false;
				
				for (methodName in Type.getClassFields(Main))
				{
					if (methodName == "main")
					{
						hasMain = true;
						break;
					}
				}
				
				if (hasMain)
				{
					Reflect.callMethod (Main, Reflect.field (Main, "main"), []);
				}
				else
				{
					nme.Lib.current.addChild(cast (Type.createInstance(Main, []), nme.display.DisplayObject));	
				}
			},
			660, 660, 
			30, 
			0xffffff,
			(true ? nme.Lib.HARDWARE : 0) |
			(false ? nme.Lib.ALLOW_SHADERS : 0) |
			(true ? nme.Lib.RESIZABLE : 0) |
			(false ? nme.Lib.BORDERLESS : 0) |
			(false ? nme.Lib.VSYNC : 0) |
			(false ? nme.Lib.FULLSCREEN : 0) |
			(1 == 4 ? nme.Lib.HW_AA_HIRES : 0) |
			(1 == 2 ? nme.Lib.HW_AA : 0),
			"Glow"
			
		);
		#end
		
	}
	
	
	public static function getAsset(inName:String):Dynamic
	{
		#if nme
		
		if (inName == "gfx/debug/console_debug.png")
		{
			
			return nme.Assets.getBitmapData ("gfx/debug/console_debug.png");
			
		}
		
		if (inName == "gfx/debug/console_logo.png")
		{
			
			return nme.Assets.getBitmapData ("gfx/debug/console_logo.png");
			
		}
		
		if (inName == "gfx/debug/console_output.png")
		{
			
			return nme.Assets.getBitmapData ("gfx/debug/console_output.png");
			
		}
		
		if (inName == "gfx/debug/console_pause.png")
		{
			
			return nme.Assets.getBitmapData ("gfx/debug/console_pause.png");
			
		}
		
		if (inName == "gfx/debug/console_play.png")
		{
			
			return nme.Assets.getBitmapData ("gfx/debug/console_play.png");
			
		}
		
		if (inName == "gfx/debug/console_step.png")
		{
			
			return nme.Assets.getBitmapData ("gfx/debug/console_step.png");
			
		}
		
		if (inName == "gfx/preloader/haxepunk.png")
		{
			
			return nme.Assets.getBitmapData ("gfx/preloader/haxepunk.png");
			
		}
		
		if (inName == "font/04B_03__.ttf")
		{
			
			return nme.Assets.getFont ("font/04B_03__.ttf");
			
		}
		
		if (inName == "gfx/Cursor.png")
		{
			
			return nme.Assets.getBitmapData ("gfx/Cursor.png");
			
		}
		
		if (inName == "gfx/Intro.png")
		{
			
			return nme.Assets.getBitmapData ("gfx/Intro.png");
			
		}
		
		if (inName == "gfx/Player1.png")
		{
			
			return nme.Assets.getBitmapData ("gfx/Player1.png");
			
		}
		
		if (inName == "gfx/Player2.png")
		{
			
			return nme.Assets.getBitmapData ("gfx/Player2.png");
			
		}
		
		if (inName == "gfx/Tiles1.png")
		{
			
			return nme.Assets.getBitmapData ("gfx/Tiles1.png");
			
		}
		
		if (inName == "gfx/Tiles2.png")
		{
			
			return nme.Assets.getBitmapData ("gfx/Tiles2.png");
			
		}
		
		if (inName == "gfx/Winner1.png")
		{
			
			return nme.Assets.getBitmapData ("gfx/Winner1.png");
			
		}
		
		if (inName == "gfx/Winner2.png")
		{
			
			return nme.Assets.getBitmapData ("gfx/Winner2.png");
			
		}
		
		#end
		return null;
	}
	
	
}
