package entities;

import com.haxepunk.Entity;
//import com.haxepunk.graphics.Image;
import com.haxepunk.graphics.Spritemap;
//import com.haxepunk.masks.Circle;

class Tile extends Entity 
{
	private var play: Array<Spritemap>;
	
    public function new(x : Float, y : Float)
    {
        super(x, y);
		
		play = new Array();
        play[1] = new Spritemap("gfx/Tiles1.png", 60, 60);
        play[2] = new Spritemap("gfx/Tiles2.png", 60, 60);
		graphic = play[1];
		
		setEmpty();
    }
	public function setEmpty() : Void
	{
		play[1].setFrame(7,7);
		play[2].setFrame(7,7);
    }
	public function setTile(player: Int, vT: Int, vL: Int, vB: Int, vR: Int) : Void
	{
		setEmpty();
		graphic = play[player];
		
		switch(vT) {
			case -1:
				switch(vL) {
					case -1:
						switch(vB) {
							case 0:
								switch(vR) {
									case 0:	play[player].setFrame(5,3);
									case 1: play[player].setFrame(7,3);
								}
							case 1:
								switch(vR) {
									case 0:	play[player].setFrame(1,4);
									case 1: play[player].setFrame(4,4);
								}
						}
					case 0:
						switch(vB) {
							case 0:
								switch(vR) {
									case -1: play[player].setFrame(4,3);
									case 0:	play[player].setFrame(1,0);
									case 1: play[player].setFrame(4,1);
								}
							case 1:
								switch(vR) {
									case -1: play[player].setFrame(0,4);
									case 0:	play[player].setFrame(3,0);
									case 1: play[player].setFrame(0,3);
								}
						}
					case 1:
						switch(vB) {
							case 0:
								switch(vR) {
									case -1: play[player].setFrame(6,3);
									case 0:	play[player].setFrame(5,1);
									case 1: play[player].setFrame(7,4);
								}
							case 1:
								switch(vR) {
									case -1: play[player].setFrame(5,4);
									case 0:	play[player].setFrame(1,3);
									case 1: play[player].setFrame(3,4);
								}
						}
				}
			case 0:
				switch(vL) {
					case -1:
						switch(vB) {
							case -1:
								switch(vR) {
									case 0:	play[player].setFrame(5,2);
									case 1: play[player].setFrame(7,2);
								}
							case 0:
								switch(vR) {
									case 0:	play[player].setFrame(0,1);
									case 1: play[player].setFrame(2,1);
								}
							case 1:
								switch(vR) {
									case 0:	play[player].setFrame(6,0);
									case 1: play[player].setFrame(2,2);
								}
						}
					case 0:
						switch(vB) {
							case -1:
								switch(vR) {
									case -1: play[player].setFrame(4,2);
									case 0:	play[player].setFrame(0,0);
									case 1: play[player].setFrame(4,0);
								}
							case 0:
								switch(vR) {
									case -1: play[player].setFrame(1,1);
									case 0:	play[player].setFrame(7,7);
									case 1: play[player].setFrame(1,7);
								}
							case 1:
								switch(vR) {
									case -1: play[player].setFrame(7,0);
									case 0:	play[player].setFrame(0,6);
									case 1: play[player].setFrame(2,6);
								}
						}
					case 1:
						switch(vB) {
							case -1:
								switch(vR) {
									case -1: play[player].setFrame(6,2);
									case 0:	play[player].setFrame(5,0);
									case 1: play[player].setFrame(6,5);
								}
							case 0:
								switch(vR) {
									case -1: play[player].setFrame(3,1);
									case 0:	play[player].setFrame(0,7);
									case 1: play[player].setFrame(6,6);
								}
							case 1:
								switch(vR) {
									case -1: play[player].setFrame(3,2);
									case 0:	play[player].setFrame(3,6);
									case 1: play[player].setFrame(4,6);
								}
						}
				}
			case 1:
				switch(vL) {
					case -1:
						switch(vB) {
							case -1:
								switch(vR) {
									case 0:	play[player].setFrame(1,5);
									case 1: play[player].setFrame(4,5);
								}
							case 0:
								switch(vR) {
									case 0:	play[player].setFrame(6,1);
									case 1: play[player].setFrame(2,3);
								}
							case 1:
								switch(vR) {
									case 0:	play[player].setFrame(6,4);
									case 1: play[player].setFrame(2,4);
								}
						}
					case 0:
						switch(vB) {
							case -1:
								switch(vR) {
									case -1: play[player].setFrame(0,5);
									case 0:	play[player].setFrame(2,0);
									case 1: play[player].setFrame(0,2);
								}
							case 0:
								switch(vR) {
									case -1: play[player].setFrame(7,1);
									case 0:	play[player].setFrame(1,6);
									case 1: play[player].setFrame(2,7);
								}
							case 1:
								switch(vR) {
									case -1: play[player].setFrame(7,5);
									case 0:	play[player].setFrame(6,7);
									case 1: play[player].setFrame(4,7);
								}
						}
					case 1:
						switch(vB) {
							case -1:
								switch(vR) {
									case -1: play[player].setFrame(5,5);
									case 0:	play[player].setFrame(1,2);
									case 1: play[player].setFrame(2,5);
								}
							case 0:
								switch(vR) {
									case -1: play[player].setFrame(3,3);
									case 0:	play[player].setFrame(3,7);
									case 1: play[player].setFrame(5,7);
								}
							case 1:
								switch(vR) {
									case -1: play[player].setFrame(3,5);
									case 0:	play[player].setFrame(5,6);
									case 1: play[player].setFrame(7,6);
								}
						}
				}
		}
		
//		play[player].setFrame(7,6);
    }
}